/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : dev_spend.cc
Last edit : 10/20/92
Created   :
Version   : 1.8

History   :

Does      :
*/
#include <stdlib.h>
#include <curses.h>

#ifndef __cplusplus__
#define __cplusplus__
#endif

#include <paths.h>
#include <mcform.h>
#include <limits.h>

#include "../skills/chosen.h"

OS_CHOSEN devo_menu(OS_CHOSEN lst, int *devo)
{
   int spells =0;
   int lkm =0;
   int *ranks;
   int i=0;
   int sivu=0;
   OS_CHOSEN n=NULL;
   OS_CHOSEN *taulu=NULL;
   int a=-1;
   int b=-1;
   int c=-1;
   char keys[20]="0123456789acdeghijkl";
   int ok=0;
   int nro=0;
   int m=' ';
   int j=0;
   int costi=-1;

   clear();
   refresh();
  
   lkm = count_skills(lst);
   ranks = (int *)calloc(lkm, sizeof(int));
   if(!ranks) {
     perror("calloc/deve_spend.cc");
     exit(0);
   }

   taulu = (OS_CHOSEN *)calloc(lkm, sizeof(OS_CHOSEN));
   if(!taulu) {
     perror("calloc/deve_spend.cc");
     exit(0);
   }
   
   n = lst;   
   for(i=0;i<lkm;i++) {
     ranks[i] = 0;
     taulu[i] = n;
     n = n->seur;
   }

   while(!ok) {
     move(0,0);
     printw("You have ");
     attron(A_REVERSE);
     printw("%3i ",*devo);
     attroff(A_REVERSE);
     printw("points to spend. You have spend ");
     attron(A_REVERSE);
     printw("%3i",spells);
     attroff(A_REVERSE);
     printw(" points to spells.");
     move(1,0);
     attron(A_UNDERLINE);
     printw(" # Skill:                    Cost:   Ranks: Total:");
     attroff(A_UNDERLINE);
     n = lst;	
     for(i=0;i<20;i++) {
       nro = sivu * 20 + i;
       move(2+i,0);
       if(nro >= lkm) 
         printw("                                                   ");
       else {
         printw(" %c  %-24s",keys[i],taulu[nro]->skill);
	 a = taulu[nro]->costa;
         b = taulu[nro]->costb;
         c = taulu[nro]->costc;
         printw("%2i",a);
         if(b!=-1)
           if(!b)
	     printw("/* /  ");
           else {
             printw("/%2i",b);
             if(c!=-1)
	       if(!c)
		 printw("/* ");
               else
                 printw("/%2i",c);
	     else
	       printw("/  ");	
           }
         else
           printw("/  /  ");	
	 printw(" %3i    %3i",ranks[nro],taulu[nro]->ranks);
       }
     }
     move(23,0);
     attron(A_BOLD);
     printw("F");
     attroff(A_BOLD);
     printw("orward, ");
     attron(A_BOLD);
     printw("B");
     attroff(A_BOLD);
     printw("ackward, ");
     attron(A_BOLD);
     printw("0-l ");
     attroff(A_BOLD);
     printw(" to choose, E");
     attron(A_BOLD);
     printw("x");
     attroff(A_BOLD);
     printw("it, ");
     attron(A_BOLD);
     printw("U");
     attroff(A_BOLD);
     printw("nchoose and ");
     attron(A_BOLD);
     printw("s");
     attroff(A_BOLD);
     printw("pells.");
     refresh();
     m = getch();
     switch(m) {
       case 'f':
         if(nro < lkm)
           sivu++;
         break;
       case 'b':
         if(sivu > 0)
           sivu--;
         break;
       case 'x':
         return lst;
       case 's':
         if(*devo) {
	   spells++;
	   (*devo)--;
	};
	break;
       case 'u':
	 move(23,0);
	 clrtoeol();
	 printw("Which one?");
	 m = getch();
         for(j=0;j< 20; j++)
           if(m == keys[j]){
             if(j+20 *sivu >=lkm)
     	       break;
             costi = -1;
	     nro = sivu * 20 + j;
	     if(!ranks[nro]) 
	       break;
 	     if(ranks[nro] == 1)
	       costi = taulu[nro]->costa;
	     else {
	       costi = (ranks[nro] > 2) ? taulu[nro]->costc : taulu[nro]->costb;
	       if((ranks[nro] > 2) && (costi == -1))
		  costi = taulu[nro]->costb ? -1 : taulu[nro]->costa; 	
	       if(!costi)
	         costi = taulu[nro]->costb ? taulu[nro]->costb : taulu[nro]->costa;
 	     }
 	     if(costi == -1)
 	       break;
	     *devo += costi;
 	     ranks[nro]--;
 	     taulu[nro]->ranks--;	
	   }
           break;
         break;
       default:
         for(j=0;j< 20; j++)
           if(m == keys[j]){
             if(j+20 *sivu >=lkm)
     	       break;
             costi = -1;
	     nro = sivu * 20 + j;
	     if(!ranks[nro]) 
	       costi = taulu[nro]->costa;
	     else {
	       costi = ranks[nro] >= 2 ? taulu[nro]->costc : taulu[nro]->costb;
	       if(!costi)
	         costi = taulu[nro]->costb ? taulu[nro]->costb : taulu[nro]->costa;
 	     }
 	     if(costi == -1 || costi > *devo)
 	       break;
	     *devo -= costi;
 	     ranks[nro]++;
 	     taulu[nro]->ranks++;	
	   }
           break;
     }
   }
   return lst;
}

