/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : deve_stat.cc
Last edit : 10/20/92
Created   :
Version   : 1.4

History   :

Does      : the developer.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curses.h>

#include <paths.h>
#include <ruutu.h>
#include <mcform.h>
#include <limits.h>

#include "../stats/st.h"
#include "../stats/stat.h"

static role_stat rstats;
extern "C" { char *mstrtok(char *, char *); }
  
int fetch_devo(char *arg)  
{
  char *directory=NULL;
  int len = 0;
  char *name=NULL;
  char *primes;
  int p=0;
  int i=0;
  int summa=0;
  FILE *src;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("deve_stat.cc/mstrtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }
  sprintf(name,"%s/%s/%s.fstats",SAVE,directory,directory);
  rstats.load(name);
  summa = (int)rstats.calc_devo(0);
  sprintf(name,"%s/%s/.spent",SAVE,directory);
  src = fopen(name,"r");
  if(!src) return summa;
  summa -= getw(src);
  fclose(src);
  return summa;
}

