/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is part of rolechar-developer program and is distributed under
   following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - If you change ANY lines or characters in ANY file of this program
     and wish to distribute modified form you must include your
     own name and document changes you have made. (Send me a copy, please.)
     (I can be reached as sahlberg@cc.Helsinki.fi from various networks)
     This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
     (You are not allowed charge anything but reasonable distribution
      cost without my permission.)
     My address is: Mauri Sahlberg
		    Pasuunakuja 2 C 16
		    SF-00420 Helsinki
		    Finland
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		*/

/* File      :	random.c					*/
/* Last edit :	17.1.1992					*/
/* Created   :	18.4.1991					*/
/* Version   :	3.0						*/

/* History   :  18-apr-1991 Created	
	        17-jan-1991 Fixed low-limit checkin, it's not fair to say
		            if(s < dlimit) s = dlimit;
*/
/* Does      :  Functions for random-number generation.	
*/



void siemen();

/* Generates random number in range [dlimit,ulimit] */
int sattuma(int dlimit, int ulimit) 
{			   
  int s;
  int range=0;
  unsigned rand();

  range = ulimit - dlimit;
  if(range < 0) range = -range;
  range++;

  s = rand() % range + dlimit;
  return s;
}

/* Sets randoms seed from clock. */
void siemen()			
{
  /* time_t time(); */
  long aika;
  /* void srand(); */
  
  (void)time(&aika);
  aika = aika % 666;
  srand((unsigned)aika);
}

#ifdef UGH
void main(int ac, char **av)
{
  int i;

  siemen();
  for(i=0;i<100;i++)
    printf("%i\n",sattuma(1,100));
}
#endif  
